﻿#include <iostream>
#include <vector>
#include <set>
using namespace std;
vector<vector<int>> graph;
vector<int> ans;
vector<int> saved;
void dfs(int v, int s, int h, int p = -1) {
    if (s <= h && h != 0) {
        saved.push_back(v+1);
    }
    for (int u : graph[v]) {
        if (u != p && s < h) {
            dfs(u, s+1, h, v);
        }
    }
}

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < n; i++) {
        vector<int> h;
        graph.push_back(h);
    }
    vector<int> powers(n, 0);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        graph[a-1].push_back(b-1);
        graph[b-1].push_back(a-1);

    }
    for (int i = 0; i < k; i++) {
        int a, b;
        cin >> a >> b;
        powers[a-1] = b;
    }
    for (int i = 0; i < n; i++) {
        dfs(i, 0, powers[i]);
    }
    set<int> set;
    for (int i = 0; i < saved.size(); i++) {
        set.insert(saved[i]);
    }
    std::set<int>::iterator iter = set.begin();
    cout << set.size() << endl;
    for (iter; iter != set.end(); iter++) {
        cout << *iter << ' ';
    }
}
